/************************************************************************
 banque.cpp
 
 Ce programme teste les possibilités d'incohérence provoquées par
 des accès concurrents (condition de course) à une même donnée.
 
 Ce programme gère un compte en banque initialisé à 1000$.
 Les opérations suivantes sont effectuées :
    - dépot de 1000$
    - dépôt de 500$
    - retrait de 15$
 Le compte final devrait être 2485$
 
*************************************************************************/
#include <thread>
#include <iostream>
#include <vector>

using namespace std;

int compte = 1000;
//------------------------------------------------------------------------
// Fontion «transaction» qui effectue les transactions
// Elle peut faire un dépot (d) ou un retrait (r)
// 
// Entrée : no - identificateur du fil
//          action - dépôt (d) ou retrait (r)
//          montant - montant à déposer ou retirer
// Sortie : *** Variable globale **
//          compte (variable globale)
//-----------------------------------------------------------------------
void transaction(int no, string action, int montant)
{
    int val;
    val = compte;
    // Affichage destiné à ralentir la transaction
    // ..... mettre en commentaire pour constater le résultat....
    // cout << "Début de la transaction et des validations "<< no << endl;
    if (action == "d") { val += montant;}
    else   {val -= montant;}
    cout << "Fin de la transaction "<< no << endl;
    compte = val;
}
//------------------------------------------------------------------------
// Programme principal
//
// Initialise et démarre des fils effectuant des transactions
//
// Entrée : attente - temps d'attente en millisecondes (ligne de commandes)
//-----------------------------------------------------------------------

int main(int argc, char *argv[])
{
    int attente = stoi(argv[1]);  // cout<< nbFil << " -- ";
    vector<thread> threads;
    //------------------------
    // Chaque démarrage de fil est séparé par une attente
    // tester les temps d'Attente : 0, 1, 2 ...
    // Les leep peuvent être mise en commentaires pour tester les résultats
    threads.push_back(thread(transaction, 1, "d", 500));
    this_thread::sleep_for(chrono::milliseconds(attente) );
    threads.push_back(thread(transaction, 2, "r", 15));
    this_thread::sleep_for(chrono::milliseconds(attente) );
    threads.push_back(thread(transaction, 1, "d", 1000));
    //-----------------
    // On attend la fin de l'exéution des fils...
    for(auto& thread : threads)  {  thread.join(); }
    //-----------------
    // Affichage du contenu du compte après les transactions
    std::cout << "Fin des transactions : compte =  " << compte << std::endl;
    return 0;
}
